/*****************************
* Source : structItemBChar.prg           
* System : <unkown>           
* Author : Phil Ide           
* Created: 15/05/2003             
*                             
* Purpose:                    
* ----------------------------
* History:                    
* ----------------------------
*    15/05/2003 14:12 PPI - Created                
*****************************/
                              
#include "common.ch"
#include "class.ch"

#define CLASS_NAME StructItemBChar

CLASS CLASS_NAME FROM StructItemBase
   PROTECTED:
      VAR length

   EXPORTED:
      METHOD init
      METHOD put
      METHOD fetch

ENDCLASS

METHOD CLASS_NAME:init(cName, nLen,byRef)

   DEFAULT nLen to 0
   ::StructItemBase:init(cName, byRef)
   ::length := nLen
   ::iLen := nLen
   ::value := ''

   if nLen > 0
      ::put( Replicate(Chr(0),::length) )
   endif

   return (self)


// When ::length > 0, the size of the character string is fixed
// otherwise it is dynamic
//
METHOD CLASS_NAME:put( c )
   local nOld := ::value
   if ValType(c) == 'C' .and. (::length < 1 .or. len(c) <= ::length)
      if ::length > 1
         c := Padr( c, ::length, Chr(0) )
      endif
      ::value  := c
   elseif ::length > 0 .and. len(c) > ::length
      ::dataOverflow(c)
   else
      ::valTypeError(c)
   endif
   return nOld

METHOD CLASS_NAME:fetch()
   return ::value


