/*****************************
* Source : structItemBase.prg           
* System : <unkown>           
* Author : Phil Ide           
* Created: 15/05/2003             
*                             
* Purpose:                    
* ----------------------------
* History:                    
* ----------------------------
*    15/05/2003 14:11 PPI - Created                
*****************************/
                              
#include "common.ch"
#include "class.ch"
#include "error.ch"

CLASS StructItemBase
   EXPORTED:
      METHOD init

      DEFERRED METHOD put
      DEFERRED METHOD fetch

      METHOD setParent
      METHOD getName
      METHOD raw
      METHOD rawPut

   PROTECTED:
      VAR parent
      VAR name
      VAR value
      VAR locked
      VAR byRef
      VAR iLen

      METHOD valTypeError
      METHOD dataOverflow

ENDCLASS

METHOD StructItemBase:init(name, byRef)
   default byRef to FALSE

   ::name  := name
   ::byRef := byRef
   ::iLen  := 0
   return self


METHOD StructItemBase:valTypeError( x )
   local o := Error():new()

   o:args            := x
   o:canDefault      := FALSE
   o:canRetry        := FALSE
   o:canSubstitute   := FALSE
   o:description     := "invalid type assignment to structure item"
   o:operation       := ::parent:className()+":"+::name+" := "+Var2Char(x)
   o:severity        := XPP_ES_ERROR
   o:subSystem       := ::className()
   o:thread          := ThreadID()
   Eval( ErrorBlock(), o )
   return self

METHOD StructItemBase:dataOverflow( x )
   local o := Error():new()

   o:args            := x
   o:canDefault      := FALSE
   o:canRetry        := FALSE
   o:canSubstitute   := FALSE
   o:description     := "data overflow error in structure member"
   o:operation       := ::parent:className()+":"+::name+" := "+Var2Char(x)
   o:severity        := XPP_ES_ERROR
   o:subSystem       := ::className()
   o:thread          := ThreadID()
   Eval( ErrorBlock(), o )
   return self



METHOD StructItemBase:setParent(o)
   ::parent := o
   return self


METHOD StructItemBase:getName()
   return ::name

METHOD StructItemBase:raw()
   return ::value

METHOD StructItemBase:rawPut(x)
   ::value := x
   return self


