/*****************************
* Source : test.prg           
* System : <unkown>           
* Author : Phil Ide           
* Created: 15/05/2003             
*                             
* Purpose:                    
* ----------------------------
* History:                    
* ----------------------------
*    15/05/2003 15:04 PPI - Created                
*****************************/
                              
#include "common.ch"
#include "xbstructures.ch"
#include "dll.ch"



STRUCTURE MyStruct
   LONG left
   ULONG right
ENDSTRUCT

STRUCTURE MyOtherStruct
   LONG ping
   ULONG pong
   STRUCT substruct AS MyStruct
ENDSTRUCT

#xtranslate .left => :left
#xtranslate .right => :right
#xtranslate .ping => :ping
#xtranslate .pong => :pong
#xtranslate .substruct => :substruct


proc main()
   local oStruct := MyOtherStruct():new()

   oStruct.ping := 21
   oStruct.pong := 74

   ? oStruct.ping
   ? oStruct.pong

   oStruct.substruct.left := 121
   oStruct.substruct.right := 127

   ? oStruct.substruct.left
   ? oStruct.substruct.right

   // deliberately cause an error
   oStruct.substruct.right := -121
   return




proc main1()
   local oStruct
   local v

   oStruct := MyStruct():new()

   oStruct.left  := 2147483647  // add 1 to generate error
   oStruct.right := 2147483648  // unsigned holds higher values

   ? oStruct.left
   ? oStruct.right

   v := oStruct:get()
   ? v

   // simulate a WinAPI function changing the data in the structure
   v := Stuff( v, 1, 4, L2Bin(21) )

   ? v

   // reload structure with new data
   oStruct:put(v)

   // examine contents
   ? oStruct.left
   ? oStruct.right

   // ok, now generate some errors

   // this attempts to assign an invalid type
   oStruct.left := "Fred"

   // this attempts to access a non-existent element
   ? oStruct:righty

   return

/*
typedef struct _devicemode {    // dvmd
    BCHAR  dmDeviceName[CCHDEVICENAME];
    WORD   dmSpecVersion;
    WORD   dmDriverVersion;
    WORD   dmSize;
    WORD   dmDriverExtra;
    DWORD  dmFields;
    union {
      struct {
        short dmOrientation;
        short dmPaperSize;
        short dmPaperLength;
        short dmPaperWidth;
      };
      POINTL dmPosition;
    };
    short  dmScale;
    short  dmCopies;
    short  dmDefaultSource;
    short  dmPrintQuality;
    short  dmColor;
    short  dmDuplex;
    short  dmYResolution;
    short  dmTTOption;
    short  dmCollate;
    BCHAR  dmFormName[CCHFORMNAME];
    WORD  dmLogPixels;
    DWORD  dmBitsPerPel;
    DWORD  dmPelsWidth;
    DWORD  dmPelsHeight;
    DWORD  dmDisplayFlags;
    DWORD  dmDisplayFrequency;
#if(WINVER >= 0x0400)
    DWORD  dmICMMethod;
    DWORD  dmICMIntent;
    DWORD  dmMediaType;
    DWORD  dmDitherType;
    DWORD  dmReserved1;
    DWORD  dmReserved2;
#if (WINVER >= 0x0500) || (_WIN32_WINNT >= 0x0400)
    DWORD  dmPanningWidth;
    DWORD  dmPanningHeight;
#endif
#endif // WINVER >= 0x0400
} DEVMODE;

*/
